/**
*	A compilacao desse arquivo tipicamente e feita pelo comando
*	@gcc main main.c -o main -I /usr/include/opencv -lcv -lm -lhighgui -lcvaux
*
**/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <cv.h>
#include <highgui.h>
#include <ctype.h>
#include "descriptors.h"

int main(int argc, char *argv[]) 
{
   IplImage *img1, *img2, *imgGCHR, *imgBICR, *imgBICLR;
   int numQuant = 64;
   
   // inicializacao com zero
   img1 = img2 = 0;

   // avisa usuario se ele nao passar imagem como argumento
   if (argc < 2) {
	printf("Usage: program <image-query>\n\7");
	exit(0);
   }
	
   img1 = cvLoadImage(argv[1], CV_LOAD_IMAGE_UNCHANGED);  // BGR  -- RGB
   // verifica se conseguiu abrir arquivo
   if (!img1) {
	printf("Cound not open image file\n");
	exit(0);
   }

   double * GCH1 = calloc(numQuant, sizeof(double));
   double * GCH2 = calloc(numQuant, sizeof(double));
   double * BIC1 = calloc(numQuant*2, sizeof(double));
   double * BIC2 = calloc(numQuant*2, sizeof(double));
   int i, j;
   
   printf("Calculating image descriptors...\n");
   GCH(img1, GCH1, numQuant);
   BIC(img1, BIC1, numQuant,1);
   
   char * filename = calloc(128,sizeof(char));
   // arrays with differences using descriptors
   double *diffGCH = (double *)calloc(80, sizeof(double)); // GCH 
   double *diffBIC = (double *)calloc(80, sizeof(double)); // BIC 
   double *diffBICL = (double *)calloc(80, sizeof(double)); // BIC + dLog
   
   double min_diffGCH = DBL_MAX, min_diffBIC = DBL_MAX, min_diffBICL = DBL_MAX;
   int min_imageGCH = 0, min_imageBIC = 0, min_imageBICL = 0;
   
   //imgGCHR = cvCreateImage(cvGetSize(img1), IPL_DEPTH_32F, 3);
   //imgBICR = cvCreateImage(cvGetSize(img1), IPL_DEPTH_32F, 3);
   
   printf("Searching image database...\n");
   for (i=0; i<80; i++) 
   {
	if (i < 10)
	    sprintf(filename,"./imagedatabase/0%d.jpg", i);
	else
	    sprintf(filename,"./imagedatabase/%d.jpg", i);
	
	printf("%s",filename);
	
	img2 = cvLoadImage(filename, CV_LOAD_IMAGE_UNCHANGED);
	if (!img2) { // verifica se conseguiu abrir arquivo
	      printf("Cound not open image file\n");
	      exit(0);
	}
	// compute descriptors
	GCH(img2, GCH2, numQuant);
	BIC(img2, BIC2, numQuant,1);
	
	// compare with query image
	diffGCH[i]= dEuclid(GCH1, GCH2, numQuant); // GCH + dist.Euclidiana
	diffBIC[i]= dManhattan(BIC1, BIC2, numQuant*2); // BIC + dist.Manhattan
	diffBICL[i]= dLog(BIC1, BIC2, numQuant*2, 1000); // BIC + dist.Logaritmica
	
        if ((diffGCH[i] < min_diffGCH) || (i == 1)){
	      min_diffGCH = diffGCH[i];
	      min_imageGCH = i;
	      imgGCHR = cvCloneImage(img2);
	      printf(" ...min GCH ");
	}
        if ((diffBIC[i] < min_diffBIC) || (i == 1)){
	      min_diffBIC = diffBIC[i];
	      min_imageBIC = i;
	      imgBICR = cvCloneImage(img2);
	      printf(" ...min BIC ");
	}
        if ((diffBICL[i] < min_diffBICL) || (i == 1)){
	      min_diffBICL = diffBICL[i];
	      min_imageBICL = i;
	      imgBICLR = cvCloneImage(img2);
	      printf(" ...min BIC+Log");
	}
        cvReleaseImage(&img2);
        printf("\n");
    }
   
   cvNamedWindow("Query", CV_WINDOW_AUTOSIZE);
   cvShowImage("Query", img1);
   cvNamedWindow("Return_GCH", CV_WINDOW_AUTOSIZE);
   cvShowImage("Return_GCH", imgGCHR);
   cvNamedWindow("Return_BIC", CV_WINDOW_AUTOSIZE);
   cvShowImage("Return_BIC", imgBICR);
   cvNamedWindow("Return_BIC_dlog", CV_WINDOW_AUTOSIZE);
   cvShowImage("Return_BIC_dlog", imgBICLR);
   cvWaitKey(0);   

   cvReleaseImage(&img1);
   cvReleaseImage(&img2);
   cvReleaseImage(&imgGCHR);
   cvReleaseImage(&imgBICR);
   cvReleaseImage(&imgBICLR);
   free(diffGCH);
   free(diffBIC);
   free(diffBICL);
   free(GCH1);
   free(GCH2);
   free(BIC1);
   free(BIC2);
   free(filename);
   
   return 0;
}